<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XBlockedLearnedPatterns StructType
 * @subpackage Structs
 */
class XBlockedLearnedPatterns extends AbstractStructBase
{
    /**
     * The description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The pattern
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $pattern;
    /**
     * The prefix
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $prefix;
    /**
     * The clusterId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $clusterId;
    /**
     * The patternType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $patternType;
    /**
     * Constructor method for XBlockedLearnedPatterns
     * @uses XBlockedLearnedPatterns::setDescription()
     * @uses XBlockedLearnedPatterns::setPattern()
     * @uses XBlockedLearnedPatterns::setPrefix()
     * @uses XBlockedLearnedPatterns::setClusterId()
     * @uses XBlockedLearnedPatterns::setPatternType()
     * @param string $description
     * @param string $pattern
     * @param string $prefix
     * @param string $clusterId
     * @param string $patternType
     */
    public function __construct($description = null, $pattern = null, $prefix = null, $clusterId = null, $patternType = null)
    {
        $this
            ->setDescription($description)
            ->setPattern($pattern)
            ->setPrefix($prefix)
            ->setClusterId($clusterId)
            ->setPatternType($patternType);
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XBlockedLearnedPatterns
     */
    public function setDescription($description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get pattern value
     * @return string|null
     */
    public function getPattern()
    {
        return $this->pattern;
    }
    /**
     * Set pattern value
     * @param string $pattern
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XBlockedLearnedPatterns
     */
    public function setPattern($pattern = null)
    {
        $this->pattern = $pattern;
        return $this;
    }
    /**
     * Get prefix value
     * @return string|null
     */
    public function getPrefix()
    {
        return $this->prefix;
    }
    /**
     * Set prefix value
     * @param string $prefix
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XBlockedLearnedPatterns
     */
    public function setPrefix($prefix = null)
    {
        $this->prefix = $prefix;
        return $this;
    }
    /**
     * Get clusterId value
     * @return string|null
     */
    public function getClusterId()
    {
        return $this->clusterId;
    }
    /**
     * Set clusterId value
     * @param string $clusterId
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XBlockedLearnedPatterns
     */
    public function setClusterId($clusterId = null)
    {
        $this->clusterId = $clusterId;
        return $this;
    }
    /**
     * Get patternType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPatternType()
    {
        return isset($this->patternType) ? $this->patternType : null;
    }
    /**
     * Set patternType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $patternType
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XBlockedLearnedPatterns
     */
    public function setPatternType($patternType = null)
    {
        if (is_null($patternType) || (is_array($patternType) && empty($patternType))) {
            unset($this->patternType);
        } else {
            $this->patternType = $patternType;
        }
        return $this;
    }
}
